import Foundation
import App


abbrev = 'Mayflower'
iconName = 'Mayflower'
longName = 'Mayflower Class'
shipFile = 'Mayflower' 
menuGroup = 'Fed Ships'
playerMenuGroup = 'Fed Ships'
species = App.SPECIES_GALAXY

Foundation.ShipDef.Mayflower = Foundation.FedShipDef(abbrev, species, { 'name': longName, 'iconName': iconName, 'shipFile': shipFile })
Foundation.ShipDef.Mayflower.fMaxWarp = 9.7
Foundation.ShipDef.Mayflower.fCruiseWarp = 7.2

# Foundation.ShipDef.Mayflower.hasTGLName = 1
# Foundation.ShipDef.Mayflower.hasTGLDesc = 1

Foundation.ShipDef.Mayflower.desc = "Mayflower Class Colony Support Ship - 274m\n\nCommissioned in 2420, as an effort to reduce costs to re-supply deep space stations, explorer ships and planetary terra-farming communities, the United Federation of planets envisioned the Mayflower Class as being the colony support workhorse for the Federation, serving many diverse roles.  They are lightly armed and shielded and although classified as medium-range starships, they cannot outmaneuver ships designed for combat and are dependent upon an escort for protection.  Mayflower class ships are capable of atmospheric flight and surface landing in direct response to the development and use of a stable form of transporter inhibitors and subspace scattering fields to impede ship to shore and site-to-site transporting of personnel and equipment.  For long distance deployment, they can be attached to specially designed Warp Sleds which increase passenger and cargo capacity and have a small shuttle bay that can hold two Type 6 shuttles and are also capable of operating as independent ships."

if menuGroup:           Foundation.ShipDef.Mayflower.RegisterQBShipMenu(menuGroup)
if playerMenuGroup:     Foundation.ShipDef.Mayflower.RegisterQBPlayerShipMenu(playerMenuGroup)

if Foundation.shipList._keyList.has_key(longName):
     Foundation.ShipDef.__dict__[longName].friendlyDetails[2] = Foundation.shipList[longName].friendlyDetails[2]
     Foundation.ShipDef.__dict__[longName].enemyDetails[2] = Foundation.shipList[longName].enemyDetails[2]




abbrev = 'Mayflower_Lander'
iconName = 'Mayflower_Lander'
longName = 'Mayflower Lander'
shipFile = 'Mayflower_Lander' 
species = App.SPECIES_GALAXY

Foundation.ShipDef.Mayflower_Lander = Foundation.FedShipDef(abbrev, species, { 'name': longName, 'iconName': iconName, 'shipFile': shipFile })
Foundation.ShipDef.Mayflower_Lander.fMaxWarp = 7.5
Foundation.ShipDef.Mayflower_Lander.fCruiseWarp = 5.2

# Foundation.ShipDef.Mayflower_Lander.hasTGLName = 1
# Foundation.ShipDef.Mayflower_Lander.hasTGLDesc = 1

Foundation.ShipDef.Mayflower_Lander.desc = "Mayflower Lander"

if menuGroup:           Foundation.ShipDef.Mayflower_Lander.RegisterQBShipMenu(menuGroup)
if playerMenuGroup:     Foundation.ShipDef.Mayflower_Lander.RegisterQBPlayerShipMenu(playerMenuGroup)

if Foundation.shipList._keyList.has_key(longName):
     Foundation.ShipDef.__dict__[longName].friendlyDetails[2] = Foundation.shipList[longName].friendlyDetails[2]
     Foundation.ShipDef.__dict__[longName].enemyDetails[2] = Foundation.shipList[longName].enemyDetails[2]




abbrev = 'Mayflower_Warpsled'
iconName = 'Mayflower_Warpsled'
longName = 'Mayflower Warpsled'
shipFile = 'Mayflower_Warpsled' 
species = App.SPECIES_GALAXY

Foundation.ShipDef.Mayflower_Warpsled = Foundation.FedShipDef(abbrev, species, { 'name': longName, 'iconName': iconName, 'shipFile': shipFile })
Foundation.ShipDef.Mayflower_Warpsled.fMaxWarp = 9.8
Foundation.ShipDef.Mayflower_Warpsled.fCruiseWarp = 7.5

# Foundation.ShipDef.Mayflower_Warpsled.hasTGLName = 1
# Foundation.ShipDef.Mayflower_Warpsled.hasTGLDesc = 1

Foundation.ShipDef.Mayflower_Warpsled.desc = "Mayflower Warpsled"

if menuGroup:           Foundation.ShipDef.Mayflower_Warpsled.RegisterQBShipMenu(menuGroup)
if playerMenuGroup:     Foundation.ShipDef.Mayflower_Warpsled.RegisterQBPlayerShipMenu(playerMenuGroup)

if Foundation.shipList._keyList.has_key(longName):
     Foundation.ShipDef.__dict__[longName].friendlyDetails[2] = Foundation.shipList[longName].friendlyDetails[2]
     Foundation.ShipDef.__dict__[longName].enemyDetails[2] = Foundation.shipList[longName].enemyDetails[2]

