import App
import Multiplayer.SpeciesToShip


def GetShipStats():
	kShipStats = {
		"FilenameHigh": "data/Models/Ships/Mayflower/Mayflower_Warpsled.nif",
		"FilenameMed": "data/Models/Ships/Mayflower/Mayflower_Warpsled.nif",
		"FilenameLow": "data/Models/ships/Mayflower/Mayflower_Warpsled.nif",
		"Name": "Mayflower Warpsled",
		"HardpointFile": "Mayflower_Warpsled",
		"Species": Multiplayer.SpeciesToShip.INTREPID
	}
	return kShipStats

def LoadModel(bPreLoad = 0):
	pStats = GetShipStats()

	# Create the LOD info
	if (not App.g_kLODModelManager.Contains(pStats["Name"])):
		# Params are: File Name, PickLeafSize, SwitchOut Distance,
		# Surface Damage Res, Internal Damage Res, Burn Value, Hole Value,
		# Search String for Glow, Search string for Specular, Suffix for specular
		pLODModel = App.g_kLODModelManager.Create(pStats["Name"])
		pLODModel.AddLOD(pStats["FilenameHigh"], 10, 200.0, 15.0, 15.0, 400, 900, "", None, None)
		pLODModel.AddLOD(pStats["FilenameMed"],  10, 400.0, 15.0, 15.0, 400, 900, "", None, None)
		pLODModel.AddLOD(pStats["FilenameLow"],  10, 800.0, 15.0, 15.0, 400, 900, "", None, None)

		if (bPreLoad == 0):
			pLODModel.Load()
		else:
			pLODModel.LoadIncremental()

def PreLoadModel():
	LoadModel(1)
